#include<gtk/gtk.h>
#include "kiel_ressource.h" //K_KnotenBreite_zu_SchriftBreite
#include "../Misc/my_dbug.h"
#include "../Misc/mem_management.h"
#include "../Syntaxtree/syntaxtree.h"
#include "../Typechecker/tc_util.h"
#include "expr_node_misc.h"


void 
insert_new_expr_node_misc(Expr_node_ptr pExpr)
{
  Expr_node_misc_ptr pMisc;

  DBUG_ENTER("insert_new_expr_node_misc");

  pExpr->misc = mtmalloc(sizeof(Expr_node_misc_struct));
  pMisc = pExpr->misc;
  if (pExpr->nodetype == e_constant) {
    if (pExpr->valuetype == real_type_index) {
      pMisc->max_drawn_digits = MAXIMALE_NACHKOMMASTELLEN;
    } else if (pExpr->valuetype == string_type_index) {
      pMisc->max_drawn_digits = MAXIMALE_ANZAHLZEICHENIMSTRING;
    } //if-switch
  } else {
    pMisc->max_drawn_digits = MAXIMALE_ANZAHLELEMENTEINLISTE;
  } //if e_constant
  pMisc->string_strrep = NULL;

  DBUG_VOID_RETURN;
} //insert_new_expr_node_misc


static void 
free_expr_node_misc(gpointer ptr)
{
  Expr_node_misc_ptr pMisc;

  DBUG_ENTER("free_expr_node_misc");

  if (ptr != NULL) {
    pMisc = ptr;
    mtfree(pMisc->string_strrep);
    mtfree(pMisc);
  } //if

  DBUG_VOID_RETURN;
} //free_expr_node_misc


void 
free_expr_node_inclusiv_misc(Expr_node_ptr pExpr)
{
  gpointer save_fp;

  DBUG_ENTER("free_expr_node_inclusiv_misc");

  save_fp               = fpFree_expr_node_misc;
  fpFree_expr_node_misc = &free_expr_node_misc;
  free_expr_node(pExpr);
  fpFree_expr_node_misc = save_fp;

  DBUG_VOID_RETURN;
} //free_expr_node_inclusiv_misc
