#include "kiel_global.h"

#include "kiel_fkt.h"
#include "kiel_fkt_priv.h"


#include "../Misc/my_dbug.h"
#include "kiel_ressource.h"

gint kiel_debug_erwuenscht_ab_ebene=1000;
gboolean kiel_debug_flex_erwuenscht=FALSE;
gboolean kiel_debug_ausw_erwuenscht=FALSE;


/* sollte nicht direkt verwendet werden, sonder nur ueber die Macros */
void kiel_debug_in_help(gint ebene,gchar *s)
{
  gint i;

  if (kiel_debug_erwuenscht_ab_ebene <= ebene) {

    for (i=0;  i < einrueck_debug_puts;  i++) {
      printf("%d",i%10); 
    } //for i
    printf("> %s\n",s);
    einrueck_debug_puts++;
  }
}

/* sollte nicht direkt verwendet werden, sonder nur ueber die Macros */
void kiel_debug_out_help(gint ebene,gchar *s)
{ 
  gint i;

  if (kiel_debug_erwuenscht_ab_ebene<=ebene) {

    einrueck_debug_puts--;
    for (i=0;i<einrueck_debug_puts;i++) {
      printf("%d",i%10);
    } //for i
    printf("< %s\n",s);
  }
}


void kiel_debug_flex_printf(gchar *token,gchar *text)
{
  if (kiel_debug_flex_erwuenscht) {
    if (text) printf("--- %s(%s)\n",token,text);
    else printf("--- %s\n",token);
  }
}


GList *Liste_aus_Ausdruckbaeumen(AUSDRUCKBAUM_TYP abaum1,...)
{
  GList *erg;
  AUSDRUCKBAUM_TYP abaum;
  va_list args;

  kiel_debug_in(8,"Liste_aus_Ausdruckbaeumen");

  erg=NULL;
  if (abaum1) {  
    erg=g_list_append(erg,abaum1);
  
    va_start(args,abaum1);
    abaum=va_arg(args,AUSDRUCKBAUM_TYP);
    while(abaum) {
      erg=g_list_append(erg,abaum);
      abaum=va_arg(args,AUSDRUCKBAUM_TYP);
    }
    va_end(args);
  }

  kiel_debug_out(8,"Liste_aus_Ausdruckbaeumen");
  return(erg);
}


gchar *string_teil(gchar *s,gint nr,gchar trennzeichen)
{
  gchar *erg;
  gint  *position;
  gint anz_trennzeichen;
  gint i,j;
  gint von,bis;

  kiel_debug_in(8,"string_teil");

  anz_trennzeichen=0;
  for(i=0;i<strlen(s);i++) if (s[i]==trennzeichen) anz_trennzeichen++;

  if ((nr<0)||(nr>anz_trennzeichen)) erg=NULL;
  else {
    position=(gint *)mtmalloc((anz_trennzeichen+2)*sizeof(gint));
    position[0]=-1;
    j=1;
    for(i=0;i<strlen(s);i++) 
      if (s[i]==trennzeichen) position[j++]=i;
    position[anz_trennzeichen+1]=strlen(s);

    von=position[nr]+1;
    bis=position[nr+1]-1;

    while((s[von]==' ')||(s[von]=='\t')) von++;
    while((s[bis]==' ')||(s[bis]=='\t')) bis--;

    erg=g_strndup(&s[von],bis-von+1);
    erg=g_strconcat(erg,"\0",NULL);

    mtfree(position);
  }

  kiel_debug_out(8,"string_teil");
  return(erg);
}


void beep()
{
  kiel_debug_in(8,"beep");

  printf("%c",0x07);
  fflush(stdout);

  kiel_debug_out(8,"beep");
}
  

void ressourcen_einlesen(gchar *dname)
{ 
  FILE *dat;
  gchar datzeile[2001];
  gchar *string_; 
  gchar *string_neu;
  gint i;
  gchar **zeile;
  gint x;
  gchar *aktzeile;
  gchar *name,*wert;

  kiel_debug_in(10,"ressourcen_einlesen");

  g_print("Lade Ressourcedatei %s ",dname);
  fflush(stdout);

  if ((dat=fopen(dname,"r"))==NULL)  {
    printf("Ressourcedatei %s nicht gefunden.\n",dname);
    gtk_exit(2);
  }

  string_=g_strdup("");
  i=1;
  while (!feof(dat)) {
    fgets(datzeile,2000,dat);
    if (!feof(dat)) { 
      string_neu=g_strconcat(string_,datzeile,NULL);
      g_free(string_);
      string_=string_neu; 
    }
    i++;
  }
  fclose(dat);

  zeile=g_strsplit(string_,"\n",0);
  g_free(string_);
  
  i=0;
  while(zeile[i]!=NULL) {
    if (strncmp(zeile[i],"#set",4)==0){
      printf(".");
      fflush(stdout);

      x=4;
      while((zeile[i][x]==' ') || (zeile[i][x]=='\t')) x++;
      aktzeile=g_strdup(&(zeile[i][x]));
      x=0;
      while((aktzeile[x]!=' ')&&(aktzeile[x]!='\t')&&(aktzeile[x]!=0x00)) x++;
      if (aktzeile[x]==0x00) {
        printf("Fehler in Ressourcedatei %s in Zeile %d.\n",dname,i);
        gtk_exit(2);
      }
      name=g_strndup(aktzeile,x);
      while((aktzeile[x]==' ')||(aktzeile[x]=='\t')) x++;
      wert=g_strdup(&aktzeile[x]);
      g_free(aktzeile);

      if(strcmp("POSITION_BEFEHLSFENSTER",name)==0)
        sscanf(wert,"%d,%d",&POSITION_BEFEHLSFENSTER_X,
                            &POSITION_BEFEHLSFENSTER_Y);
      else if(strcmp("POSITION_BAUMFENSTER",name)==0)
        sscanf(wert,"%d,%d",&POSITION_BAUMFENSTER_X,
                            &POSITION_BAUMFENSTER_Y);
      else if(strcmp("POSITION_ZEICHENREIHENFENSTER",name)==0)
        sscanf(wert,"%d,%d",&POSITION_ZEICHENREIHENFENSTER_X,
                            &POSITION_ZEICHENREIHENFENSTER_Y);
      else if(strcmp("POSITION_ADKUEBERSICHTSFENSTER",name)==0)
        sscanf(wert,"%d,%d",&POSITION_ADKUEBERSICHTSFENSTER_X,
                            &POSITION_ADKUEBERSICHTSFENSTER_Y);
      else if(strcmp("POSITION_RVUEBERSICHTSFENSTER",name)==0)
        sscanf(wert,"%d,%d",&POSITION_RVUEBERSICHTSFENSTER_X,
                            &POSITION_RVUEBERSICHTSFENSTER_Y);
      else if(strcmp("POSITION_UNDOREDOFENSTER",name)==0)
        sscanf(wert,"%d,%d",&POSITION_UNDOREDOFENSTER_X,
                            &POSITION_UNDOREDOFENSTER_Y);
      else if(strcmp("POSITION_ADKFILESELECTION",name)==0)
        sscanf(wert,"%d,%d",&POSITION_ADKFILESELECTION_X,
                            &POSITION_ADKFILESELECTION_Y);
      else if(strcmp("POSITION_PRGFILESELECTION",name)==0)
        sscanf(wert,"%d,%d",&POSITION_PRGFILESELECTION_X,
                            &POSITION_PRGFILESELECTION_Y);
      else if(strcmp("POSITION_AUSDRUCKEINGABEFENSTER",name)==0)
        sscanf(wert,"%d,%d",&POSITION_AUSDRUCKEINGABEFENSTER_X,
                            &POSITION_AUSDRUCKEINGABEFENSTER_Y);
      else if(strcmp("POSITION_AUSWERTUNGSFENSTER",name)==0)
        sscanf(wert,"%d,%d",&POSITION_AUSWERTUNGSFENSTER_X,
                            &POSITION_AUSWERTUNGSFENSTER_Y);
      else if(strcmp("POSITION_WARNUNGSFENSTER",name)==0)
        sscanf(wert,"%d,%d",&POSITION_WARNUNGSFENSTER_X,
                            &POSITION_WARNUNGSFENSTER_Y);
      else if(strcmp("BREITE_DRAWING_AREA_BAUM",name)==0)
        BREITE_DRAWING_AREA_BAUM=atoi(wert);
      else if(strcmp("HOEHE_DRAWING_AREA_BAUM",name)==0)
        HOEHE_DRAWING_AREA_BAUM=atoi(wert); 
      else if(strcmp("BREITE_SCROLLEDWINDOW_ZR",name)==0)
        BREITE_SCROLLEDWINDOW_ZR=atoi(wert);
      else if(strcmp("BREITE_AUSDRUCKEINGABEFENSTER_ENTRY",name)==0)
        BREITE_AUSDRUCKEINGABEFENSTER_ENTRY=atoi(wert);
      else if(strcmp("BREITE_UEBERSICHTS_SCROLLED_WIN",name)==0)
        BREITE_UEBERSICHTS_SCROLLED_WIN=atoi(wert);
      else if(strcmp("HOEHE_UEBERSICHTS_SCROLLED_WIN",name)==0)
        HOEHE_UEBERSICHTS_SCROLLED_WIN=atoi(wert);
      else if(strcmp("DURCHMESSER_NACHKOMMASTELLEN_DIAL",name)==0)
        DURCHMESSER_NACHKOMMASTELLEN_DIAL=atoi(wert);
      else if(strcmp("VORGABE_NACHKOMMASTELLEN",name)==0)
        VORGABE_NACHKOMMASTELLEN=atoi(wert);
      else if(strcmp("MAXIMALE_NACHKOMMASTELLEN",name)==0)
        MAXIMALE_NACHKOMMASTELLEN=atoi(wert);
      else if(strcmp("VORGABE_ANZAHLZEICHENIMSTRING",name)==0)
        VORGABE_ANZAHLZEICHENIMSTRING=atoi(wert);
      else if(strcmp("MAXIMALE_ANZAHLZEICHENIMSTRING",name)==0)
        MAXIMALE_ANZAHLZEICHENIMSTRING=atoi(wert);
      else if(strcmp("VORGABE_ANZAHLELEMENTEINLISTE",name)==0)
        VORGABE_ANZAHLELEMENTEINLISTE=atoi(wert);
      else if(strcmp("MAXIMALE_ANZAHLELEMENTEINLISTE",name)==0)
        MAXIMALE_ANZAHLELEMENTEINLISTE=atoi(wert);
      else if(strcmp("ABBRUCH_EXPANSIONS_TIEFE",name)==0)
        ABBRUCH_EXPANSIONS_TIEFE=atoi(wert);
      else if(strcmp("MAX_ANZUZEIGENDE_EBENEN_ANZ",name)==0)
        MAX_ANZUZEIGENDE_EBENEN_ANZ=atoi(wert);
      else if(strcmp("WINDOW_AUSDRUCK_DATEIAUSWAHL_DIRECTORY",name)==0)
        WINDOW_AUSDRUCK_DATEIAUSWAHL_DIRECTORY=g_strdup(wert);
      else if(strcmp("WINDOW_PROGRAMM_DATEIAUSWAHL_DIRECTORY",name)==0)
        WINDOW_PROGRAMM_DATEIAUSWAHL_DIRECTORY=g_strdup(wert);
      else if(strcmp("BUTTON_MLAUSDRUCK_UEBERSICHT_STATUS",name)==0)
        BUTTON_MLAUSDRUCK_UEBERSICHT_STATUS=(strncmp(wert,"TRUE",4)==0);
      else if(strcmp("BUTTON_RV_UEBERSICHT_STATUS",name)==0)
        BUTTON_RV_UEBERSICHT_STATUS=(strncmp(wert,"TRUE",4)==0);
      else if(strcmp("BUTTON_AUSDRUCKBAUM_FENSTER_STATUS",name)==0)
        BUTTON_AUSDRUCKBAUM_FENSTER_STATUS=(strncmp(wert,"TRUE",4)==0);
      else if(strcmp("BUTTON_ZEICHENREIHEN_FENSTER_STATUS",name)==0)
        BUTTON_ZEICHENREIHEN_FENSTER_STATUS=(strncmp(wert,"TRUE",4)==0);
      else if(strcmp("BUTTON_UNDOREDO_FENSTER_STATUS",name)==0)
        BUTTON_UNDOREDO_FENSTER_STATUS=(strncmp(wert,"TRUE",4)==0);
      else if(strcmp("BUTTON_AUSWERTUNGS_FENSTER_STATUS",name)==0)
        BUTTON_AUSWERTUNGS_FENSTER_STATUS=(strncmp(wert,"TRUE",4)==0);
      else if(strcmp("BUTTON_LI_STATUS",name)==0)
        BUTTON_LI_STATUS=(strncmp(wert,"TRUE",4)==0);
      else if(strcmp("BUTTON_LO_STATUS",name)==0)
        BUTTON_LO_STATUS=(strncmp(wert,"TRUE",4)==0);
      else if(strcmp("BUTTON_FULL_STATUS",name)==0)
        BUTTON_FULL_STATUS=(strncmp(wert,"TRUE",4)==0);
      else if(strcmp("BUTTON_1_SCHRITT_STATUS",name)==0)
        BUTTON_1_SCHRITT_STATUS=(strncmp(wert,"TRUE",4)==0);
      else if(strcmp("BUTTON_5_SCHRITTE_STATUS",name)==0)
        BUTTON_5_SCHRITTE_STATUS=(strncmp(wert,"TRUE",4)==0);
      else if(strcmp("BUTTON_10_SCHRITTE_STATUS",name)==0)
        BUTTON_10_SCHRITTE_STATUS=(strncmp(wert,"TRUE",4)==0);
      else if(strcmp("BUTTON_VAR_SCHRITTE_STATUS",name)==0)
        BUTTON_VAR_SCHRITTE_STATUS=(strncmp(wert,"TRUE",4)==0);
      else if(strcmp("BUTTON_BIS_FERTIG_STATUS",name)==0)
        BUTTON_BIS_FERTIG_STATUS=(strncmp(wert,"TRUE",4)==0);
      else if(strcmp("GK_OFFSET_H",name)==0)
        K_OffsetH=atoi(wert);
      else if(strcmp("GK_OFFSET_V",name)==0)
        K_OffsetV=atoi(wert);
      else if(strcmp("GK_ZEILENHOEHE",name)==0)
        K_Zeilenhoehe=atoi(wert);
      else if(strcmp("GK_KNOTEN_MINDESTABSTAND",name)==0)
        K_KnotenMindestabstand=atoi(wert);
      else if(strcmp("GK_KNOTENBREITE_ZU_SCHRIFTBREITE",name)==0)
        K_KnotenBreite_zu_SchriftBreite=g_strtod(wert,NULL);
      else if(strcmp("GK_KNOTENHOEHE_ZU_SCHRIFTHOEHE",name)==0)
        K_KnotenHoehe_zu_SchriftHoehe=g_strtod(wert,NULL);
      else { 
        printf("unbekannter Name in Ressourcedatei %s.\n",dname); 
        printf("Zeile %d:|%s|%s|\n",i,name,wert);
        gtk_exit(2);
      }

      g_free(name);
      g_free(wert);
    }
    i++;
  }
  g_strfreev(zeile);

  g_print("\n");

  kiel_debug_out(10,"ressourcen_einlesen");
}
