#ifndef _KIEL_GLOBAL_H
#define _KIEL_GLOBAL_H



#include <stdio.h>
#include <stdlib.h> 
#include <stdarg.h> /* fr variable Argumentanzahlen */
#include <string.h>
#include <math.h>
#include <gtk/gtk.h>
#include "../Misc/mem_management.h"

//#define DEBUGINCLUDE_ERWUENSCHT

typedef struct RetValStruct
{
  gint      typ;

  gpointer *_unit;
  gboolean  _bool;
  gint      _int;
  gdouble   _real;
  gchar    *_string;
  GList    *_list;
} RETVAL_STRUCT;
typedef RETVAL_STRUCT  *RETVAL_TYP;



typedef struct WetShaTypStruct
{
  gdouble x;
  gdouble modifier;
} WetShaTyp;


/* Ausdruckbaum-Typ */
typedef struct ausdruckBaumStruct
{
  RETVAL_TYP                 wert;            /* Wert des Knotens            */
  gint                       anz_stellen;     /* Nachkommastellen bei real-  */
                                              /* Ausdrcken, Zeichenanzahl   */
                                              /* bei string-Ausdrcken und   */
                                              /* Komponentenanzahl bei Se-   */
                                              /* quenzausdrcken             */
  gint                       nodeIdentifier;  /* Art des Knotens             */
  gboolean                   ausgewertet;     /* Ist Knoten ausgewertet?     */
  GList                     *kinder;          /* Kinder des Knotens          */
  gint                       zeile; 
  gdouble                    spalte;          /* Zeile und Spalte in der     */
                                              /* Baumdarstellung (abhngig   */
                                              /* vom Baumzeichenalgorithmus) */
  WetShaTyp                  WetSha;          /* fr Positionierung nach     */
                                              /* Wetherell und Shannon       */
  gint                       expansionstiefe; /* Expansionstiefe             */
  gboolean                   full_expansion;  /* Hier koennen RV-Aufrufe     */
                                              /* markiert werden, die zu     */
                                              /* expandieren sind.           */
} AUSDRUCKBAUM_STRUCT;
typedef AUSDRUCKBAUM_STRUCT         *AUSDRUCKBAUM_TYP;


/* Pixmap-DrawingArea-Daten-Typ */
typedef struct pixmap_drawingarea_daten_typ
{
  GdkPixmap               *pixm;          /* Adresse der Pixmap             */
  GtkWidget               *draw_a;        /* Adresse des Drawing Area       */
} PIXMAP_DRAWINGAREA_DATEN_STRUCT;
typedef PIXMAP_DRAWINGAREA_DATEN_STRUCT   *PIXMAP_DRAWINGAREA_DATEN_TYP;


/* Protokoll-Typ */
typedef struct ProtokollStruct
{
  GList                        *liste;         /* Liste des Auswertungsproto-*/
                                               /* kolls fr Undo und Redo    */
  gint                          position;      /* Position im Protokoll      */
} PROTOKOLL_STRUCT;
typedef PROTOKOLL_STRUCT *PROTOKOLL_TYP;


/* Ausdruck-Typ */
typedef struct ausdruck_typ
{
  gchar                        *datei_name;      /* Dateiname der Adk.-Datei */
                                                 /* bei RVs "".             */
  AUSDRUCKBAUM_TYP              baum;            /* Ausdrucksbaum            */
  AUSDRUCKBAUM_TYP              ursprungsbaum;   /* Um Undo machen zu knnen */
  gboolean                      Zeichnen_erlaubt;/* darf Adk. gezeichnet     */
                                                 /* werden?                  */
  gchar                        *eingabe_string;  /* Eingabe-String           */
  GList                        *knotenliste;     /* Knotenliste zum          */
                                                 /* einfacheren Ansprechen   */
                                                 /* der Knoten im Baum       */
  PROTOKOLL_TYP                 protokoll;       /* Auswertungsprotokoll fr */
                                                 /* Undo und Redo            */
} AUSDRUCK_STRUCT;
typedef AUSDRUCK_STRUCT  *AUSDRUCK_TYP;


/* Argument-Typ */
typedef struct argument_typ
{
  gchar                   *name;          /* Name                            */
  gint                     sorte;         /* Sorte                           */
} ARGUMENT_STRUCT;
typedef ARGUMENT_STRUCT    *ARGUMENT_TYP;


/* Rechenvorschrift-Typ */
typedef struct rechenvorschrift_struct
{  
  gchar                   *datei_name;    /* Dateiname                       */
  gchar                   *name;          /* Name                            */
  GList                   *argumente;     /* Argumente                       */
  gint                     ergebnissorte; /* Ergebnissorte                   */
  AUSDRUCK_TYP             rumpf;         /* Rumpf                           */
  gchar                   *eingabe_string;/* Eingabe-String                  */
} RECHENVORSCHRIFT_STRUCT;
typedef RECHENVORSCHRIFT_STRUCT         *RECHENVORSCHRIFT_TYP;

/* RV-Name-Sorte-Typ */
typedef struct rv_name_sorte_struct
{  
  gchar                   *name;          /* Name                            */
  gint                     sorte;         /* Sorte                           */
  gchar                   *eingabe_string;/* Eingabe-String                  */
} RV_NAME_SORTE_STRUCT;
typedef RV_NAME_SORTE_STRUCT         *RV_NAME_SORTE_TYP;


/* Fenster-Strukturen */
/* Befehlsfenster */
#define BUTTON_MLAUSDRUCK_LADEN      0x01
#define BUTTON_MLAUSDRUCK_EINGEBEN   0x02
#define BUTTON_MLAUSDRUCK_UEBERSICHT 0x03
#define BUTTON_MLPROGRAMM_LADEN      0x04
#define BUTTON_RV_UEBERSICHT         0x05
#define BUTTON_AUSDRUCKBAUM_FENSTER  0x06
#define BUTTON_ZEICHENREIHEN_FENSTER 0x07
#define BUTTON_UNDOREDO_FENSTER      0x08
#define BUTTON_AUSWERTUNGS_FENSTER   0x09
#define BUTTON_CALLGRAPH	     0x10
typedef struct befehlsfenster_daten_struct
{
  GtkWidget                    *fenster;
  gint                          timer_id;
  GtkWidget                    *button_ausdruckbaum,
                               *button_zeichenreihe,
                               *button_adkuebersicht,
                               *button_rvuebersicht,
                               *button_undoredo,
                               *button_auswertung;
  PIXMAP_DRAWINGAREA_DATEN_TYP  pixdraw[5];
} BEFEHLSFENSTER_STRUCT;
typedef BEFEHLSFENSTER_STRUCT *BEFEHLSFENSTER_TYP;


/* Baum-Fenster */
typedef struct baumfenster_daten_struct
{
  GtkWidget                    *fenster;
  GtkWidget                    *statuslabel;
  PIXMAP_DRAWINGAREA_DATEN_TYP  pix_draw;
  GtkWidget                    *sw_frame;
  GtkAdjustment                *adjustmenth,*adjustmentv;
  gint                          daten_breite,daten_hoehe;
  GtkWidget                    *popup_menu;
  GtkAdjustment                *pop_adjustment;
} BAUMFENSTER_STRUCT;
typedef BAUMFENSTER_STRUCT *BAUMFENSTER_TYP;


/* Zeichenreihen-Fenster */
typedef struct zeichenreihenfenster_daten_struct
{
  GtkWidget                    *fenster;
  GtkWidget                    *zr_scrolledw;
  GtkWidget                    *zeichenreihen_label;
} ZEICHENREIHENFENSTER_STRUCT;
typedef ZEICHENREIHENFENSTER_STRUCT *ZEICHENREIHENFENSTER_TYP;


/* bersichts-Fenster */
#define UEBERSICHTSFENSTER_AUSDRUCK         0x01
#define UEBERSICHTSFENSTER_RECHENVORSCHRIFT 0x02
typedef struct uebersichtsfenster_daten_struct
{
  GtkWidget *fenster;
  GtkWidget *liste;
} UEBERSICHTSFENSTER_STRUCT;
typedef UEBERSICHTSFENSTER_STRUCT *UEBERSICHTSFENSTER_TYP;


/* Undo-Redo-Fenster */
#define BUTTON_1_ZURUECK   0x01
#define BUTTON_5_ZURUECK   0x02
#define BUTTON_10_ZURUECK  0x03
#define BUTTON_VAR_ZURUECK 0x04
#define BUTTON_1_VOR       0x05
#define BUTTON_5_VOR       0x06
#define BUTTON_10_VOR      0x07
#define BUTTON_VAR_VOR     0x08
typedef struct undoredofenster_daten_struct
{
  GtkWidget *fenster;
  GtkWidget *progressbar;
  GtkWidget *button_var_zurueck,*button_var_vor;
  GtkWidget *entry_zurueck,*entry_vor;
  GtkWidget *label_max_zurueck,*label_max_vor;
} UNDOREDOFENSTER_STRUCT;
typedef UNDOREDOFENSTER_STRUCT *UNDOREDOFENSTER_TYP;


/* Ausdruckeingabe-Fenster */
typedef struct ausdruckeingabefenster_daten_struct
{
  GtkWidget *fenster;
  GtkWidget *entry;
} AUSDRUCKEINGABEFENSTER_STRUCT;
typedef AUSDRUCKEINGABEFENSTER_STRUCT *AUSDRUCKEINGABEFENSTER_TYP;


/* Auswertungsfenster */
typedef struct auswertungsfenster_daten_struct
#define BUTTON_AUSWERTUNG_ABBRUCH      0x01
{
  GtkWidget *fenster;
  GtkWidget *button_auswertungsart[3];
  GtkWidget *button_schritte[5];
  GtkWidget *entry;
} AUSWERTUNGSFENSTER_STRUCT;
typedef AUSWERTUNGSFENSTER_STRUCT *AUSWERTUNGSFENSTER_TYP;


/* Rckgabe-Struktur fr pruefe_ob_zu_RV_Aufruf_RV_ex_und_ok aus kiel_adk */
#define POZRAREUO_KEIN_FEHLER             0x00
#define POZRAREUO_FEHLER_FALSCHE_ERGSORTE 0x01
#define POZRAREUO_FEHLER_ANZ_ARG          0x02
#define POZRAREUO_FEHLER_FALSCHE_SORTE    0x03
typedef struct pozRAReuo_RueckgabeStruct
{
  gint   fehler;
  gchar *sorte0,*sorte1;
  gchar *rv_funk;
  gint   anz0,anz1;
  gint   nr; 
} POZRAREUO_RUECKGABE_STRUCT;
typedef POZRAREUO_RUECKGABE_STRUCT *POZRAREUO_RUECKGABE_TYP;
 

int global_opt_full_eval;
char *global_opt_read_prg;
char *global_opt_read_exp;

#endif //_KIEL_GLOBAL_H
