#include "kiel_global.h"

#include "kiel_gtk_aef.h"
#include "kiel_gtk_aef_priv.h"
#include "kiel_gtk_fenster.h"
#include "kiel_gtk.h"
#include "kiel_gtk_df.h"
#include "kiel_gtk_wf.h"

#include "kiel_fkt.h"

#include "kiel_ressource.h"
#include "../Misc/error_interface.h"
#include "../Syntaxtree/syntaxtree.h"
#include "../Syntaxtree/st_io.h"
#include "drawable_expr.h"


void ausdruckeingabefenster_button_press_callback(GtkWidget *widget)
{ 
  //gchar *entry_text; 

  kiel_debug_in(10,"ausdruckeingabefenster_button_press_callback");

  if (warnungs_fenster_geoeffnet()) beep();
  else {
    //entry_text =gtk_entry_get_text(GTK_ENTRY(ausdruckeingabefenster->entry));
    gtk_entry_set_text(GTK_ENTRY(ausdruckeingabefenster->entry), ""); 
    gtk_widget_hide(ausdruckeingabefenster->fenster);
  }

  kiel_debug_out(10,"ausdruckeingabefenster_button_press_callback");
}


void ausdruckeingabefenster_entry_enter_callback(GtkWidget *widget)
{ 
  gchar *entry_text; 
  GList **MLAdksP;
  //  GList **MLRVsP;
  Expr_node_ptr pExpr;
  Drawable_expr_ptr pDrawExpr;

  kiel_debug_in(10,"ausdruckeingabefenster_entry_enter_callback");
 
  if (warnungs_fenster_geoeffnet()) beep();
  else {
    MLAdksP = hole_adresse_von_MLAusdruecke();
    //MLRVsP = hole_adresse_von_MLRechenvorschriften();

    entry_text = gtk_entry_get_text(GTK_ENTRY(ausdruckeingabefenster->entry));
    gtk_entry_select_region(GTK_ENTRY(ausdruckeingabefenster->entry), 0,
                            strlen(entry_text));
         
    pExpr = readExprFromString(entry_text);
    if (pExpr != NULL) {
      pDrawExpr = create_drawable_expr(pExpr);
      pExpr = NULL;
      *MLAdksP = g_list_append(*MLAdksP, pDrawExpr);
      GTK_Ausdruecke();

      /* Ausdruck-bersichtsfenster anzeigen */
      if (*MLAdksP) {
	trotz_warnung_auf_true();
	ADK_Uebersichtsfenster_Toggle_Button_an();
	trotz_warnung_auf_false();
      }
    } else {
      Warnungs_Fenster_oeffnen(getErrorDescription_nr_buttons(), 
			       getErrorDescription_buttonlabel1(),
			       getErrorDescription_line0(), 
			       getErrorDescription_line1(), 
			       getErrorDescription_line2(), 
			       getErrorDescription_line3(),
			       getErrorDescription_line4(), 
			       getErrorDescription_line5(), NULL);
    } //if (pExpr != NULL)
  }

  kiel_debug_out(10,"ausdruckeingabefenster_entry_enter_callback");
}


void ausdruckeingabefenster_changed_callback(GtkWidget *widget)
{ 
  //gchar *entry_text; 

  kiel_debug_in(10,"ausdruckeingabefenster_changed_callback");

  if (warnungs_fenster_geoeffnet()) beep();

  kiel_debug_out(10,"ausdruckeingabefenster_changed_callback");
}


void erzeuge_Ausdruckeingabe_Fenster(AUSDRUCKEINGABEFENSTER_TYP aef)
{
  kiel_debug_in(10,"erzeuge_Ausdruckeingabe_Fenster");
 
  /* Fenster erzeugen, Position und Gre setzen */
  aef->fenster=gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(aef->fenster),
                       WINDOW_AUSDRUCKEINGABEFENSTER_TEXT);
  gtk_widget_set_uposition(aef->fenster,POSITION_AUSDRUCKEINGABEFENSTER_X,
                                        POSITION_AUSDRUCKEINGABEFENSTER_Y);
  gtk_window_set_policy(GTK_WINDOW(aef->fenster),FALSE,TRUE,TRUE);
  gtk_signal_connect(GTK_OBJECT(aef->fenster),"delete_event",
                 GTK_SIGNAL_FUNC(ausdruckeingabefenster_button_press_callback),
                     NULL);
  gtk_container_border_width(GTK_CONTAINER(aef->fenster),5);

  {
    GtkWidget *vbox,*hbox;
    GtkWidget *button;

    /* VBox im Fenster erzeugen */
    vbox=gtk_vbox_new(FALSE,0);
    gtk_container_add(GTK_CONTAINER(aef->fenster),vbox);
    gtk_widget_show(vbox); 
     
    /* Entry oben */
    aef->entry=gtk_entry_new();
    gtk_widget_set_usize(aef->entry,BREITE_AUSDRUCKEINGABEFENSTER_ENTRY,25); 
    gtk_signal_connect(GTK_OBJECT(aef->entry),"activate",
                  GTK_SIGNAL_FUNC(ausdruckeingabefenster_entry_enter_callback),
                       NULL);
    gtk_signal_connect(GTK_OBJECT(aef->entry),"changed",
                      GTK_SIGNAL_FUNC(ausdruckeingabefenster_changed_callback),
                       NULL);
    gtk_entry_set_text(GTK_ENTRY(aef->entry),""); 
    gtk_box_pack_start(GTK_BOX(vbox),aef->entry,FALSE,FALSE,5);
    gtk_widget_show (aef->entry);
    /* HBox unten */
    hbox=gtk_hbox_new(FALSE,0);
    gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
    gtk_widget_show(hbox); 
    /* Close-Button in HBox */
    button=gtk_button_new_with_label(BUTTON_AUSDRUCKEINGABE_CLOSE_TEXT); 
    gtk_signal_connect(GTK_OBJECT(button),"clicked",
                 GTK_SIGNAL_FUNC(ausdruckeingabefenster_button_press_callback),
                       NULL);
    gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,FALSE,5);
    gtk_widget_show(button); 
  }
 
  kiel_debug_out(10,"erzeuge_Ausdruckeingabe_Fenster");
}
