#include "kiel_global.h"

#include "kiel_gtk_urf.h"
#include "kiel_gtk_urf_priv.h"
#include "kiel_gtk_fenster.h"
#include "kiel_gtk_uef.h"
#include "kiel_gtk.h"

  #include "kiel_fkt.h"

#include "kiel_ressource.h"
#include "kiel_gtk_bmf.h"
#include "undoredo.h"


void undoredofenster_button_press_callback(GtkWidget *widget,gpointer *data)
{
  gint buttonnr;
  gchar *entry_text;
  gint wert;
  BAUMFENSTER_TYP *bmfensterP;
  Drawable_expr_ptr pDrawExpr;

  kiel_debug_in(10,"undoredofenster_button_press_callback");

  if (warnungs_fenster_geoeffnet()) beep();
  else {
    bmfensterP = hole_adresse_von_baumfenster();
    setze_zuletzt_bearbeitet_abaum_auf_NULL();

    buttonnr  = GPOINTER_TO_INT(data);
    pDrawExpr = hole_markierten_Ausdruck();
    switch (buttonnr) {
      /* Zurck-Button */
      case(BUTTON_1_ZURUECK)  :
	undo(pDrawExpr, 1);
	freshen_positioning(pDrawExpr, *bmfensterP);

	break;
      case(BUTTON_5_ZURUECK)  :
	undo(pDrawExpr, 5);
	freshen_positioning(pDrawExpr, *bmfensterP);
	break;

      case(BUTTON_10_ZURUECK) :
	undo(pDrawExpr, 10);
	freshen_positioning(pDrawExpr, *bmfensterP);
	break;

      case(BUTTON_VAR_ZURUECK):
	entry_text = gtk_entry_get_text(GTK_ENTRY(
		       undoredofenster->entry_zurueck));
	wert = strtol(entry_text, NULL, 10);
	undo(pDrawExpr, wert);
	freshen_positioning(pDrawExpr, *bmfensterP);

	break;

      /* Vor-Button */
      case(BUTTON_1_VOR)  :
	redo(pDrawExpr, 1);
	freshen_positioning(pDrawExpr, *bmfensterP);
	break;

      case(BUTTON_5_VOR)  :
	redo(pDrawExpr, 5);
	freshen_positioning(pDrawExpr, *bmfensterP);
	break;

      case(BUTTON_10_VOR) :
	redo(pDrawExpr, 10);
	freshen_positioning(pDrawExpr, *bmfensterP);
	break;

      case(BUTTON_VAR_VOR):
	entry_text = gtk_entry_get_text(GTK_ENTRY(
                       undoredofenster->entry_vor));
	wert = strtol(entry_text, NULL, 10);
	redo(pDrawExpr, wert);
	freshen_positioning(pDrawExpr, *bmfensterP);
	break;

      default:puts("exit in switch ::undoredofensterbutton_press_callback");
              gtk_exit(1);
    }
  }

  kiel_debug_out(10,"undoredofenster_button_press_callback");
}


void undoredofenster_entry_zurueck_changed_callback(GtkWidget *widget)
{ 
  gchar *text;
  gint anz;
  gchar *neues_label;

  kiel_debug_in(10,"undoredofenster_entry_zurueck_changed_callback");

  if (warnungs_fenster_geoeffnet()) beep();
  else {
    text=gtk_entry_get_text(GTK_ENTRY(undoredofenster->entry_zurueck));

    anz=strtol(text,NULL,10);
    anz=MAX(0,anz);
    neues_label=g_strdup_printf("%d %s",anz,LABEL_VAR_SCHRITTE_TEXT);
    gtk_label_set(GTK_LABEL(GTK_BIN(undoredofenster->button_var_zurueck)
                            ->child),
                  neues_label);
    g_free(neues_label);
  }

  kiel_debug_out(10,"undoredofenster_entry_zurueck_changed_callback");
}


void undoredofenster_entry_vor_changed_callback(GtkWidget *widget)
{ 
  gchar *text;
  gint anz;
  gchar *neues_label;

  kiel_debug_in(10,"undoredofenster_entry_vor_changed_callback");

  if (warnungs_fenster_geoeffnet()) beep();
  else {
    text=gtk_entry_get_text(GTK_ENTRY(undoredofenster->entry_vor));

    anz=strtol(text,NULL,10);
    anz=MAX(0,anz);
    neues_label=g_strdup_printf("%d %s",anz,LABEL_VAR_SCHRITTE_TEXT);
    gtk_label_set(GTK_LABEL(GTK_BIN(undoredofenster->button_var_vor)->child),
                  neues_label);
    g_free(neues_label);
  }

  kiel_debug_out(10,"undoredofenster_entry_vor_changed_callback");
}


void erzeuge_Undo_Redo_Fenster(UNDOREDOFENSTER_TYP urf)
{
  kiel_debug_in(10,"erzeuge_Undo_Redo_Fenster");
 
  /* Fenster erzeugen, Position und Gre setzen */
  urf->fenster=gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(urf->fenster),WINDOW_UNDOREDOFENSTER_TEXT);
  gtk_widget_set_uposition(urf->fenster,POSITION_UNDOREDOFENSTER_X,
                                        POSITION_UNDOREDOFENSTER_Y);
  gtk_window_set_policy(GTK_WINDOW(urf->fenster),FALSE,FALSE,FALSE);
  gtk_signal_connect(GTK_OBJECT(urf->fenster),"delete_event",
                     GTK_SIGNAL_FUNC(Undo_Redofenster_Toggle_Button_aus),NULL);
  gtk_container_border_width(GTK_CONTAINER(urf->fenster),5);

  {
    GtkWidget *vbox;
     
    /* VBox im Fenster erzeugen */
    vbox=gtk_vbox_new(FALSE,0);
    gtk_container_add(GTK_CONTAINER(urf->fenster),vbox);
    gtk_widget_show(vbox); 
     
    { 
      GtkAdjustment *adjustment;
      GtkWidget *alignment;
      GtkWidget *hbox;
  
      /* Alignment erzeugen */
      alignment=gtk_alignment_new(0.5,0.5,0,0);
      gtk_box_pack_start(GTK_BOX(vbox),alignment,FALSE,FALSE,5);
      gtk_widget_show(alignment);
      /* ProgressBar in Alignment erzeugen */
      adjustment=(GtkAdjustment *)gtk_adjustment_new(0,0,0,0,0,0);
      urf->progressbar=gtk_progress_bar_new_with_adjustment(adjustment);
      gtk_progress_set_format_string(GTK_PROGRESS(urf->progressbar),
                                     PROGRESSBAR_TEXT);
      gtk_progress_bar_set_bar_style(GTK_PROGRESS_BAR(urf->progressbar),
                                     GTK_PROGRESS_CONTINUOUS); 
      gtk_progress_set_show_text(GTK_PROGRESS(urf->progressbar),TRUE);
      gtk_progress_set_activity_mode(GTK_PROGRESS(urf->progressbar),FALSE);
      gtk_container_add(GTK_CONTAINER(alignment),urf->progressbar);
      gtk_widget_show(urf->progressbar);

      /* HBox in den Vbox fr die Frames */
      hbox=gtk_hbox_new(FALSE,5);
      gtk_container_add(GTK_CONTAINER(vbox),hbox);
      gtk_widget_show(hbox); 

      {
        GtkWidget *frame;
        GtkWidget *vbox_frame;
  
        /* Frame fr zurck erzeugen */
        frame=gtk_frame_new(FRAME_SCHRITTE_ZURUECK_TEXT); 
        gtk_box_pack_start(GTK_BOX(hbox),frame,FALSE,FALSE,0);
        gtk_widget_show(frame); 
        /* VBox in den Frame */
        vbox_frame=gtk_vbox_new(FALSE,5);
        gtk_container_border_width(GTK_CONTAINER(vbox_frame),5);
        gtk_container_add(GTK_CONTAINER(frame),vbox_frame);
        gtk_widget_show(vbox_frame); 

        {
          GtkWidget *label;
          GtkWidget *button;
          GtkWidget *separator;

          {
            GtkWidget *hbox_frame;

            /* HBox_Frame in den Vbox_Frame */
            hbox_frame=gtk_hbox_new(FALSE,0);
            gtk_box_pack_start(GTK_BOX(vbox_frame),hbox_frame,FALSE,FALSE,0);
            gtk_widget_show(hbox_frame); 

            /* Label maximal zurck erzeugen */ 
            label=gtk_label_new(LABEL_MAXIMAL_TEXT);
            gtk_box_pack_start(GTK_BOX(hbox_frame),label,FALSE,FALSE,0);
            gtk_widget_show(label);
            /* Label maximal wert zurck erzeugen */ 
            urf->label_max_zurueck=gtk_label_new("0");
            gtk_box_pack_start(GTK_BOX(hbox_frame),urf->label_max_zurueck,
                               TRUE,TRUE,0);
            gtk_widget_show(urf->label_max_zurueck);       
          }

          /* waagerechten Separator erzeugen */
          separator=gtk_hseparator_new();
          gtk_box_pack_start(GTK_BOX(vbox_frame),separator,FALSE,FALSE,0);
          gtk_widget_show(separator);

          /* Button 1 Schritt zurck erzeugen */
          button=gtk_button_new_with_label(LABEL_1_SCHRITT_TEXT);
          gtk_signal_connect(GTK_OBJECT(button),"clicked",
                        GTK_SIGNAL_FUNC(undoredofenster_button_press_callback),
                          GINT_TO_POINTER(BUTTON_1_ZURUECK));
          gtk_box_pack_start(GTK_BOX(vbox_frame),button,FALSE,FALSE,0);
          gtk_widget_show(button);
          /* Button 5 Schritte zurck erzeugen */
          button=gtk_button_new_with_label(LABEL_5_SCHRITTE_TEXT);
          gtk_signal_connect(GTK_OBJECT(button),"clicked",
                        GTK_SIGNAL_FUNC(undoredofenster_button_press_callback),
                          GINT_TO_POINTER(BUTTON_5_ZURUECK));
          gtk_box_pack_start(GTK_BOX(vbox_frame),button,FALSE,FALSE,0);
          gtk_widget_show(button);
          /* Button 10 Schritte zurck erzeugen */
          button=gtk_button_new_with_label(LABEL_10_SCHRITTE_TEXT);
          gtk_signal_connect(GTK_OBJECT(button),"clicked",
                        GTK_SIGNAL_FUNC(undoredofenster_button_press_callback),
                          GINT_TO_POINTER(BUTTON_10_ZURUECK));
          gtk_box_pack_start(GTK_BOX(vbox_frame),button,FALSE,FALSE,0);
          gtk_widget_show(button);

          {
            GtkWidget *hbox_frame;

            /* HBox_Frame in den Vbox_Frame */
            hbox_frame=gtk_hbox_new(FALSE,5);
            gtk_box_pack_start(GTK_BOX(vbox_frame),hbox_frame,FALSE,FALSE,0);
            gtk_widget_show(hbox_frame); 

            /* Button variable Schritte zurck erzeugen */
            urf->button_var_zurueck=
              gtk_button_new_with_label(LABEL_VAR_SCHRITTE_TEXT);
            { 
              gchar *s;

              s=g_strdup_printf("X9999 %s",LABEL_VAR_SCHRITTE_TEXT);
              gtk_widget_set_usize(urf->button_var_zurueck,
                      gdk_string_width(urf->button_var_zurueck->style->font,s),
                                   22);
              g_free(s);
            }
            gtk_signal_connect(GTK_OBJECT(urf->button_var_zurueck),"clicked",
                        GTK_SIGNAL_FUNC(undoredofenster_button_press_callback),
                            GINT_TO_POINTER(BUTTON_VAR_ZURUECK));
            gtk_box_pack_start(GTK_BOX(hbox_frame),urf->button_var_zurueck,
                               TRUE,TRUE,0);
            gtk_widget_show(urf->button_var_zurueck);
            /* Entry variable Schritte zurck erzeugen */
            urf->entry_zurueck=gtk_entry_new_with_max_length(4);
            gtk_widget_set_usize(urf->entry_zurueck,36,20);
            gtk_signal_connect(GTK_OBJECT(urf->entry_zurueck),"changed",
               GTK_SIGNAL_FUNC(undoredofenster_entry_zurueck_changed_callback),
                               NULL);
            gtk_entry_set_text(GTK_ENTRY(urf->entry_zurueck),"");
            gtk_box_pack_start(GTK_BOX(hbox_frame),urf->entry_zurueck,
                               FALSE,FALSE,0);
            gtk_widget_show(urf->entry_zurueck);
          }
	}
      }

      {
        GtkWidget *frame;
        GtkWidget *vbox_frame;
  
        /* Frame fr vor erzeugen */
        frame=gtk_frame_new(FRAME_SCHRITTE_VOR_TEXT); 
        gtk_box_pack_start(GTK_BOX(hbox),frame,FALSE,FALSE,0);
        gtk_widget_show(frame); 
        /* VBox in den Frame */
        vbox_frame=gtk_vbox_new(FALSE,5);
        gtk_container_border_width(GTK_CONTAINER(vbox_frame),5);
        gtk_container_add(GTK_CONTAINER(frame),vbox_frame);
        gtk_widget_show(vbox_frame); 

        {
          GtkWidget *label;
          GtkWidget *button;
          GtkWidget *separator;

          {
            GtkWidget *hbox_frame;

            /* HBox_Frame in den Vbox_Frame */
            hbox_frame=gtk_hbox_new(FALSE,0);
            gtk_box_pack_start(GTK_BOX(vbox_frame),hbox_frame,FALSE,FALSE,0);
            gtk_widget_show(hbox_frame); 

            /* Label maximal vor erzeugen */ 
            label=gtk_label_new(LABEL_MAXIMAL_TEXT);
            gtk_box_pack_start(GTK_BOX(hbox_frame),label,FALSE,FALSE,0);
            gtk_widget_show(label);
            /* Label maximal wert vor erzeugen */ 
            urf->label_max_vor=gtk_label_new("0");
            gtk_box_pack_start(GTK_BOX(hbox_frame),urf->label_max_vor,
                               TRUE,TRUE,0);
            gtk_widget_show(urf->label_max_vor);       
          }

          /* waagerechten Separator erzeugen */
          separator=gtk_hseparator_new();
          gtk_box_pack_start(GTK_BOX(vbox_frame),separator,FALSE,FALSE,0);
          gtk_widget_show(separator);

          /* Button 1 Schritt vor erzeugen */
          button=gtk_button_new_with_label(LABEL_1_SCHRITT_TEXT);
          gtk_signal_connect(GTK_OBJECT(button),"clicked",
                        GTK_SIGNAL_FUNC(undoredofenster_button_press_callback),
                          GINT_TO_POINTER(BUTTON_1_VOR));
          gtk_box_pack_start(GTK_BOX(vbox_frame),button,FALSE,FALSE,0);
          gtk_widget_show(button);
          /* Button 5 Schritte vor erzeugen */
          button=gtk_button_new_with_label(LABEL_5_SCHRITTE_TEXT);
          gtk_signal_connect(GTK_OBJECT(button),"clicked",
                        GTK_SIGNAL_FUNC(undoredofenster_button_press_callback),
                          GINT_TO_POINTER(BUTTON_5_VOR));
          gtk_box_pack_start(GTK_BOX(vbox_frame),button,FALSE,FALSE,0);
          gtk_widget_show(button);
          /* Button 10 Schritte vor erzeugen */
          button=gtk_button_new_with_label(LABEL_10_SCHRITTE_TEXT);
          gtk_signal_connect(GTK_OBJECT(button),"clicked",
                        GTK_SIGNAL_FUNC(undoredofenster_button_press_callback),
                          GINT_TO_POINTER(BUTTON_10_VOR));
          gtk_box_pack_start(GTK_BOX(vbox_frame),button,FALSE,FALSE,0);
          gtk_widget_show(button);

          {
            GtkWidget *hbox_frame;

            /* HBox_Frame in den Vbox_Frame */
            hbox_frame=gtk_hbox_new(FALSE,5);
            gtk_box_pack_start(GTK_BOX(vbox_frame),hbox_frame,FALSE,FALSE,0);
            gtk_widget_show(hbox_frame); 

            /* Button variable Schritte vor erzeugen */
            urf->button_var_vor=
              gtk_button_new_with_label(LABEL_VAR_SCHRITTE_TEXT);
            { 
              gchar *s;

              s=g_strdup_printf("X9999 %s",LABEL_VAR_SCHRITTE_TEXT);
              gtk_widget_set_usize(urf->button_var_vor,
                          gdk_string_width(urf->button_var_vor->style->font,s),
                                   22);
              g_free(s);
            }
            gtk_signal_connect(GTK_OBJECT(urf->button_var_vor),"clicked",
                        GTK_SIGNAL_FUNC(undoredofenster_button_press_callback),
                            GINT_TO_POINTER(BUTTON_VAR_VOR));
            gtk_box_pack_start(GTK_BOX(hbox_frame),urf->button_var_vor,
                               TRUE,TRUE,0);
            gtk_widget_show(urf->button_var_vor);
            /* Entry variable Schritte vor erzeugen */
            urf->entry_vor=gtk_entry_new_with_max_length(4);
            gtk_widget_set_usize(urf->entry_vor,36,20);
            gtk_signal_connect(GTK_OBJECT(urf->entry_vor),"changed",
                   GTK_SIGNAL_FUNC(undoredofenster_entry_vor_changed_callback),
                               NULL);
            gtk_entry_set_text(GTK_ENTRY(urf->entry_vor),"");
            gtk_box_pack_start(GTK_BOX(hbox_frame),urf->entry_vor,
                               FALSE,FALSE,0);
            gtk_widget_show(urf->entry_vor);
          }
	}
      }
    }
  }

  /* ggf. anzeigen */
  if (BUTTON_UNDOREDO_FENSTER_STATUS) gtk_widget_show(urf->fenster);

  kiel_debug_out(10,"erzeuge_Undo_Redo_Fenster");
}
