#ifndef _MEM_MANAGEMENT_H
#define _MEM_MANAGEMENT_H



#include <gtk/gtk.h>
#ifdef DBUG_OFF //original line
//#ifndef qDBUG_OFF //debug line
#  include <stdlib.h>
#  define         mtstrdup(src)        mtstrdup_dbug_off(src)
#  define         mtmalloc(size)       g_malloc0(size)
#  define         mtrealloc(old, size) g_realloc(old, size)
#  define         mtfree(ptr)          g_free(ptr)
#  define         MTFREENULL(ptr)      { g_free(ptr); ptr = NULL; }
#  define         mtshowtotals(tag) 
#  define         PRINTF_MTSLOTS
#else
#  define         mtstrdup(src)   mtstrdup_dbug_on(src, __FILE__, __LINE__)
#  define         mtmalloc(size)  mtmalloc_dbug_on(size, __FILE__, __LINE__)
#  define         mtrealloc(o, s) mtrealloc_dbug_on(o, s, __FILE__, __LINE__)
#  define         mtfree(ptr)     mtfree_dbug_on(ptr, __FILE__, __LINE__)
#  define         MTFREENULL(ptr) { mtfree_dbug_on(ptr, __FILE__, __LINE__); \
                                    ptr = NULL; }
#  define         mtshowtotals(tag)  mtshowtotals_dbug_on(tag)
#  define         PRINTF_MTSLOTS     printf_mtslots_dbug_on()
#endif

extern gchar*   mtstrdup_dbug_on (gchar* src, gchar* file, gint line);
extern gchar*   mtstrdup_dbug_off(gchar* src);
extern gchar*   mtstrconcat(int nrArgs, ...);

extern void     mtmemory_init(void);
extern gpointer mtmalloc_dbug_on(gsize size, gchar* file,gint line);
extern gpointer mtrealloc_dbug_on(gpointer old_ptr, gsize size, gchar* file, 
				  gint line);
extern void     mtfree_dbug_on(gpointer ptr, gchar* file, gint line);
extern void     mtmultifree(gint nrArgs, ...);

extern void     mtshowtotals_dbug_on(gchar* tag);
extern void     printf_mtslots_dbug_on(void);


#endif //_MEM_MANAGEMENT_H
